# inherited before_script and after_script from '../templates/build.yml'

.build.jayeson.portal.vodds_static:
  stage: build
  extends:
    - .testroot
    - .cleanup
  variables:
    GIT_CLONE_PATH: "$CI_BUILDS_DIR/$CI_PROJECT_NAMESPACE/$CI_CONCURRENT_ID/$CI_PROJECT_NAME-build/$CI_PROJECT_NAME"
  image: 315865776134.dkr.ecr.ap-northeast-1.amazonaws.com/templates/ubuntu18/gradle-node:5.6.1-10.15.0
  script:
    - cp -fr ./$CI_PROJECT_NAME/conf-sample ./$CI_PROJECT_NAME/conf
    - cp pipeline-tools/vodds/static/build-node.sh ./$CI_PROJECT_NAME/nodejspackage/
    - cd $CI_PROJECT_NAME/nodejspackage
    - sh build-node.sh ${PREFIX_BUILD}
    - cd ../app-client/mobile
    - npm install
    - npm run dist
    - cd ../../../test-root
    - gradle :$CI_PROJECT_NAME:clean :$CI_PROJECT_NAME:publishDeploy${PREFIX_BUILD} --info --stacktrace $BUILD_XARG
  artifacts:
    reports:
      dotenv: .env
  tags:
    - docker
  allow_failure: false


.build.jayeson.portal.vodds.agent:
  stage: build
  extends:
    - .testroot
    - .cleanup
  variables:
    GIT_CLONE_PATH: "$CI_BUILDS_DIR/$CI_PROJECT_NAMESPACE/$CI_CONCURRENT_ID/$CI_PROJECT_NAME-build/$CI_PROJECT_NAME"
  image: 315865776134.dkr.ecr.ap-northeast-1.amazonaws.com/templates/ubuntu18/gradle-node:5.6.1-10.15.0
  script:
    - cp -fr ./$CI_PROJECT_NAME/conf-sample ./$CI_PROJECT_NAME/conf
    - cp pipeline-tools/vodds/agent/build-node.sh ./$CI_PROJECT_NAME/app-client/
    - cd ./$CI_PROJECT_NAME/app-client
    - sh build-node.sh
    - cd ../../test-root
    - gradle :$CI_PROJECT_NAME:clean :$CI_PROJECT_NAME:publishDeploy${PREFIX_BUILD} --info --stacktrace $BUILD_XARG
  artifacts:
    reports:
      dotenv: .env
  tags:
    - docker
  allow_failure: false


.build.jayeson.portal.vodds_registration:
  stage: build
  extends:
    - .testroot
    - .cleanup
  variables:
    GIT_CLONE_PATH: "$CI_BUILDS_DIR/$CI_PROJECT_NAMESPACE/$CI_CONCURRENT_ID/$CI_PROJECT_NAME-build/$CI_PROJECT_NAME"
  image: 315865776134.dkr.ecr.ap-northeast-1.amazonaws.com/templates/ubuntu18/gradle-node:5.6.1-10.15.0
  script:
    - cp -fr ./$CI_PROJECT_NAME/conf-sample ./$CI_PROJECT_NAME/conf
    - cp pipeline-tools/vodds/registration/build-node.sh ./$CI_PROJECT_NAME/nodejspackage/
    - cd ./$CI_PROJECT_NAME/nodejspackage
    - sh build-node.sh
    - cd ../../test-root
    - gradle :$CI_PROJECT_NAME:clean :$CI_PROJECT_NAME:publishDeploy${PREFIX_BUILD} --info --stacktrace $BUILD_XARG
  artifacts:
    reports:
      dotenv: .env
  tags:
    - docker
  allow_failure: false


.build.jayeson.vodds.workflowdesign:
  stage: build
  extends:
    - .cleanup
  variables:
    GIT_CLONE_PATH: "$CI_BUILDS_DIR/$CI_PROJECT_NAMESPACE/$CI_CONCURRENT_ID/$CI_PROJECT_NAME-build/$CI_PROJECT_NAME"
  image: 315865776134.dkr.ecr.ap-northeast-1.amazonaws.com/templates/custom:maven3.3.9
  script:
    - find deployment/ -type f -name "applicationContext.xml" -exec cp -f {} src/main/webapp/WEB-INF/ \;
    - find deployment/ -type f -name "SpringBeans.xml" -exec cp -f {} src/main/resources \;
    - mvn install
  artifacts:
    reports:
      dotenv: .env
    paths:
      - target/
    expire_in: 30 mins
  tags:
    - docker
  allow_failure: false


.build.jayeson.service.vodds_tools:
  stage: build
  extends:
    - .master
    - .cleanup
  variables:
    GIT_CLONE_PATH: "$CI_BUILDS_DIR/$CI_PROJECT_NAMESPACE/$CI_CONCURRENT_ID/$CI_PROJECT_NAME-build/$CI_PROJECT_NAME"
  image: 315865776134.dkr.ecr.ap-northeast-1.amazonaws.com/templates/ubuntu18/gradle-node:4.6-14.15.1
  script:
    - cp -fr ./$CI_PROJECT_NAME/conf-sample ./$CI_PROJECT_NAME/conf
    - cp pipeline-tools/vodds/vodds_tool/buildnode.sh ./$CI_PROJECT_NAME/app-client
    - cd ./$CI_PROJECT_NAME/app-client
    - sh buildnode.sh
    - cd ../../master
    - gradle :$CI_PROJECT_NAME:clean :$CI_PROJECT_NAME:dist --info --stacktrace $BUILD_XARG
  artifacts:
    paths:
      - build/distributions
    reports:
      dotenv: .env
  cache:
    paths:
      - $PROJECT_PATH/app-client/node_modules/
  tags:
    - docker
  allow_failure: false

.build.jayeson.service.vodds_tools_hnct:
  stage: build
  extends:
    - .testroot
    - .cleanup
  variables:
    GIT_CLONE_PATH: "$CI_BUILDS_DIR/$CI_PROJECT_NAMESPACE/$CI_CONCURRENT_ID/$CI_PROJECT_NAME-build/$CI_PROJECT_NAME"
  image: 315865776134.dkr.ecr.ap-northeast-1.amazonaws.com/templates/ubuntu18/gradle-node:5.6.1-10.15.0
  script:
    - cp -fr ./$CI_PROJECT_NAME/conf-sample ./$CI_PROJECT_NAME/conf
    - cp pipeline-tools/vodds/vodds_tool/buildnode.sh ./$CI_PROJECT_NAME/app-client
    - cd ./$CI_PROJECT_NAME/app-client
    - sh buildnode.sh
    - cd ../../test-root
    - gradle :$CI_PROJECT_NAME:clean :$CI_PROJECT_NAME:publishDeploy${PREFIX_BUILD} --info --stacktrace $BUILD_XARG
  artifacts:
    reports:
      dotenv: .env
  tags:
    - docker
  allow_failure: false


.build.jayeson.vodds.watchliststats:
  stage: build
  extends:
    - .testroot
    - .cleanup
  variables:
    GIT_CLONE_PATH: "$CI_BUILDS_DIR/$CI_PROJECT_NAMESPACE/$CI_CONCURRENT_ID/$CI_PROJECT_NAME-build/$CI_PROJECT_NAME"
  image: 315865776134.dkr.ecr.ap-northeast-1.amazonaws.com/templates/ubuntu18/gradle-node:5.6.1-10.15.0
  script:
    - >
      if [ -d "$CI_PROJECT_NAME/conf-sample" ]; then
        cp -fr $CI_PROJECT_NAME/conf-sample $CI_PROJECT_NAME/conf
      fi
    - cd test-root
    - gradle :$CI_PROJECT_NAME:clean :$CI_PROJECT_NAME:shadowJar --info --stacktrace $BUILD_XARG
  artifacts:
    reports:
      dotenv: .env
    paths:
      - build/libs
  tags:
    - docker
  allow_failure: false

.build.jayeson.service.vodds.config:
  stage: build
  extends:
    - .master
    - .cleanup
  variables:
    GIT_CLONE_PATH: "$CI_BUILDS_DIR/$CI_PROJECT_NAMESPACE/$CI_CONCURRENT_ID/$CI_PROJECT_NAME-build/$CI_PROJECT_NAME"
  image: 315865776134.dkr.ecr.ap-northeast-1.amazonaws.com/templates/ubuntu18/gradle-node:4.6-10.15.0
  script:
    - >
      if [ -d "$CI_PROJECT_NAME/conf-sample" ]; then
        cp -fr $CI_PROJECT_NAME/conf-sample $CI_PROJECT_NAME/conf
      fi
    - cd $CI_PROJECT_NAME
    - gradle clean dist --info --stacktrace $BUILD_XARG
  tags:
    - docker
  artifacts:
    paths:
      - build/
    expire_in: 1 week
  allow_failure: false


.build.jayeson.vodds.service.creditalert:
  stage: build
  extends:
    - .master
    - .cleanup
  variables:
    GIT_CLONE_PATH: "$CI_BUILDS_DIR/$CI_PROJECT_NAMESPACE/$CI_CONCURRENT_ID/$CI_PROJECT_NAME-build/$CI_PROJECT_NAME"
  image: 315865776134.dkr.ecr.ap-northeast-1.amazonaws.com/templates/ubuntu18/gradle-node:4.6-10.15.0
  script:
    - >
      if [ -d "$CI_PROJECT_NAME/conf-sample" ]; then
        cp -fr $CI_PROJECT_NAME/conf-sample $CI_PROJECT_NAME/conf
      fi
    - cd $CI_PROJECT_NAME
    - gradle distCombined --info --stacktrace $BUILD_XARG
  tags:
    - docker
  artifacts:
    paths:
      - build/
    expire_in: 1 week
  allow_failure: false

.build.jayeson.portal.vodds_registration_node14:
  stage: build
  extends:
    - .testroot
    - .cleanup
  variables:
    GIT_CLONE_PATH: "$CI_BUILDS_DIR/$CI_PROJECT_NAMESPACE/$CI_CONCURRENT_ID/$CI_PROJECT_NAME-build/$CI_PROJECT_NAME"
  image: 315865776134.dkr.ecr.ap-northeast-1.amazonaws.com/templates/ubuntu18/gradle-node:5.6.1-14.15.1
  script:
    - cp -fr ./$CI_PROJECT_NAME/conf-sample ./$CI_PROJECT_NAME/conf
    - cd ./$CI_PROJECT_NAME/nodejspackage
    - npm install
    - grunt
    - cd ../app-client/
    - npm install
    - npm install -g @angular/cli
    - ng build --prod
    - cd ../../test-root
    - gradle :$CI_PROJECT_NAME:clean :$CI_PROJECT_NAME:publishDeploy${PREFIX_BUILD} --info --stacktrace $BUILD_XARG
  artifacts:
    reports:
      dotenv: .env
  tags:
    - docker
  allow_failure: false